Index: configure
===================================================================
--- configure	(revision 73431)
+++ configure	(working copy)
@@ -1,5 +1,5 @@
 #! /bin/sh
-# From configure.ac Revision: 72597 .
+# From configure.ac Revision: 72766 .
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by GNU Autoconf 2.61.
 #
@@ -15321,6 +15321,48 @@
 #define HAVE_RES_NINIT 1
 _ACEOF
 
+	{ echo "$as_me:$LINENO: checking for res_ndestroy" >&5
+echo $ECHO_N "checking for res_ndestroy... $ECHO_C" >&6; }
+	cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+#include <resolv.h>
+int
+main ()
+{
+int foo = res_ndestroy(NULL);
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext conftest$ac_exeext
+if { (ac_try="$ac_link"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_link") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest$ac_exeext &&
+       $as_test_x conftest$ac_exeext; then
+  { echo "$as_me:$LINENO: result: yes" >&5
+echo "${ECHO_T}yes" >&6; }
+
+cat >>confdefs.h <<\_ACEOF
+#define HAVE_RES_NDESTROY 1
+_ACEOF
+
 else
   echo "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
@@ -15332,7 +15374,18 @@
 
 rm -f core conftest.err conftest.$ac_objext conftest_ipa8_conftest.oo \
       conftest$ac_exeext conftest.$ac_ext
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
 
+	{ echo "$as_me:$LINENO: result: no" >&5
+echo "${ECHO_T}no" >&6; }
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest_ipa8_conftest.oo \
+      conftest$ac_exeext conftest.$ac_ext
+
 { echo "$as_me:$LINENO: checking for RTLD_NOLOAD" >&5
 echo $ECHO_N "checking for RTLD_NOLOAD... $ECHO_C" >&6; }
 cat >conftest.$ac_ext <<_ACEOF
Index: configure.ac
===================================================================
--- configure.ac	(revision 73431)
+++ configure.ac	(working copy)
@@ -334,7 +334,15 @@
 	AC_LANG_PROGRAM([#include <resolv.h>],
 			[int foo = res_ninit(NULL);]),
 	AC_MSG_RESULT(yes)
-	AC_DEFINE([HAVE_RES_NINIT], 1, [Define to 1 if your system has the re-entrant resolver functions.]),
+	AC_DEFINE([HAVE_RES_NINIT], 1, [Define to 1 if your system has the re-entrant resolver functions.])
+	AC_MSG_CHECKING(for res_ndestroy)
+	AC_LINK_IFELSE(
+		AC_LANG_PROGRAM([#include <resolv.h>],
+				[int foo = res_ndestroy(NULL);]),
+		AC_MSG_RESULT(yes)
+		AC_DEFINE([HAVE_RES_NDESTROY], 1, [Define to 1 if your system has the ndestroy resolver function.]),
+		AC_MSG_RESULT(no)
+	),
 	AC_MSG_RESULT(no)
 )
 
Index: include/asterisk/autoconfig.h.in
===================================================================
--- include/asterisk/autoconfig.h.in	(revision 73431)
+++ include/asterisk/autoconfig.h.in	(working copy)
@@ -289,6 +289,9 @@
 /* Define to 1 if you have the `regcomp' function. */
 #undef HAVE_REGCOMP
 
+/* Define to 1 if your system has the ndestroy resolver function. */
+#undef HAVE_RES_NDESTROY
+
 /* Define to 1 if your system has the re-entrant resolver functions. */
 #undef HAVE_RES_NINIT
 
Index: main/dns.c
===================================================================
--- main/dns.c	(revision 73431)
+++ main/dns.c	(working copy)
@@ -216,7 +216,11 @@
 			ret = 1;
 	}
 #if HAVE_RES_NINIT
+#if HAVE_RES_NDESTROY
+	res_ndestroy(&dnsstate);
+#else
 	res_nclose(&dnsstate);
+#endif
 #else
 #ifndef __APPLE__
 	res_close();
